## nvidia-cuda-toolkit 9.1.85

=== local/cuda-9.1/extras/CUPTI/sample/callback_metric/Makefile ===
#
# Copyright 2011-2015 NVIDIA Corporation. All rights reserved
# 
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti
    endif
    OBJ = o
endif

callback_metric: callback_metric.$(OBJ)
	nvcc -o $@ callback_metric.$(OBJ) $(LIBS)

callback_metric.$(OBJ): callback_metric.cu
	nvcc -c $(INCLUDES) $<

run: callback_metric
	./$<

clean:
	rm -f callback_metric callback_metric.$(OBJ)

=== local/cuda-9.1/extras/CUPTI/sample/event_sampling/Makefile ===
#
# Copyright 2011-2015 NVIDIA Corporation. All rights reserved
# 
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti -lpthread
    endif
    OBJ = o
endif

event_sampling: event_sampling.$(OBJ)
	nvcc -o $@ event_sampling.$(OBJ) $(LIBS)

event_sampling.$(OBJ): event_sampling.cu
	nvcc -c $(INCLUDES) $<

run: event_sampling
	./$<

clean:
	rm -f event_sampling event_sampling.$(OBJ)

=== local/cuda-9.1/extras/CUPTI/sample/nvlink_bandwidth/Makefile ===
#
# Copyright 2015-2016 NVIDIA Corporation. All rights reserved.
# 
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti
    endif
    OBJ = o
endif

nvlink_bandwidth: nvlink_bandwidth.$(OBJ)
	nvcc -o $@ nvlink_bandwidth.$(OBJ) $(LIBS)

nvlink_bandwidth.$(OBJ): nvlink_bandwidth.cu
	nvcc -c $(INCLUDES) $<

run: nvlink_bandwidth
	./$<

clean:
	rm -f nvlink_bandwidth nvlink_bandwidth.$(OBJ)

=== local/cuda-9.1/extras/CUPTI/sample/openacc_trace/Makefile ===
#
# Copyright 2015 NVIDIA Corporation. All rights reserved
#

# CUPTI OpenACC support is only available on Linux x86_64 and ppc64le.

# Point to your PGI OpenACC installation's include directory.
# PGI compiler must be in PATH.
OPENACC_INCLUDE_PATH =

HOST_ARCH := $(shell uname -m)

INCLUDES += -I../../include
INCLUDES += -I../../../../include
INCLUDES += -I$(OPENACC_INCLUDE_PATH)

PGCPP       = pgc++
PGCPP_FLAGS = -acc -ta=nvidia:cuda7.0 -Mcuda=nordc -pgf90libs
ifneq ($(HOST_ARCH),ppc64le)
        PGCPP_FLAGS += -tp=p7 -mp=nonuma
else
        PGCPP_FLAGS += -DHOST_ARCH_PPC=1
endif

export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib64
TRACE_LIB = libopenacc_trace.so

all: openacc_app

$(TRACE_LIB): openacc_trace.cpp
	$(PGCPP) $(INCLUDES) -DCUPTI_OPENACC_SUPPORT -fPIC -shared -o $@ $<

openacc_app: $(TRACE_LIB) openacc_app.cpp
	$(PGCPP) $(INCLUDES) $(PGCPP_FLAGS)         \
	-L. -L../../lib64  -lopenacc_trace -lcupti  \
	-o $@ $^

run: $(TRACE_LIB) openacc_app
	ACC_PROFLIB=$(TRACE_LIB) ./openacc_app

clean:
	rm -f $(TRACE_LIB) openacc_app

=== local/cuda-9.1/extras/CUPTI/sample/pc_sampling/Makefile ===
#
# Copyright 2014-2015 NVIDIA Corporation. All rights reserved
#
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti
    endif
    OBJ = o
endif

pc_sampling: pc_sampling.$(OBJ)
	nvcc -o $@ pc_sampling.$(OBJ) $(LIBS)

pc_sampling.$(OBJ): pc_sampling.cu
	nvcc -arch=sm_52 -lineinfo  -c $(INCLUDES) $<

run: pc_sampling
	./$<

clean:
	rm -f pc_sampling pc_sampling.$(OBJ)

=== local/cuda-9.1/extras/CUPTI/sample/unified_memory/Makefile ===
#
# Copyright 2013-2015 NVIDIA Corporation. All rights reserved
# 
INCLUDES=-I../../include

ifndef OS
 OS   := $(shell uname)
 HOST_ARCH := $(shell uname -m)
endif

ifeq ($(OS),Windows_NT)
    export PATH := $(PATH):../../libWin32:../../libx64
    LIBS= -lcuda -L ../../libWin32 -L ../../libx64 -lcupti
    OBJ = obj
else
    ifeq ($(OS), Darwin)
        export DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):../../lib
        LIBS= -Xlinker -framework -Xlinker cuda -L ../../lib -lcupti
    else
        export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):../../lib:../../lib64
        LIBS= -lcuda -L ../../lib -L ../../lib64 -lcupti
    endif
    OBJ = o
endif

ifeq ($(OS), Darwin)
unified_memory:
	@echo "Unified memory is not supported on MacOSX. Build/clean/run aborted."
else
unified_memory: unified_memory.$(OBJ)
	nvcc -o $@ unified_memory.$(OBJ) $(LIBS)

unified_memory.$(OBJ): unified_memory.cu
	nvcc -c $(INCLUDES) $<

run: unified_memory
	./$<

clean:
	rm -f unified_memory unified_memory.$(OBJ)
endif

=== debian/changelog ===
nvidia-cuda-toolkit (9.1.85-8~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 08 Jan 2019 16:07:19 +0100

nvidia-cuda-toolkit (9.1.85-8) unstable; urgency=medium

  * libnppc9.1: Abuse this high scoring package and add Conflicts/Breaks
    against nvidia-libopencl1 and older nvidia-opencl-dev to enforce
    switching to ocl-icd-opencl-dev on nvidia-cuda-toolkit upgrades.
  * Bump Standards-Version to 4.3.0 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Mon, 24 Dec 2018 14:10:43 +0100

nvidia-cuda-toolkit (9.1.85-7~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Use openjdk-8-jre for stretch.
  * Do not build nvidia-openjdk-8-jre for stretch.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 14 Dec 2018 20:45:14 +0100

nvidia-cuda-toolkit (9.1.85-7) unstable; urgency=medium

  * d/rules: Simplify shifting around the unpacked contents.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 09 Dec 2018 04:57:24 +0100

nvidia-cuda-toolkit (9.1.85-6) unstable; urgency=medium

  * nvidia-opencl-dev: Add Breaks: nvidia-libopencl1 for a smoother transition
    to ocl-icd-opencl-dev.
  * *.symbols: Add Build-Depends-Package.
  * Switch to debhelper-compat (= 11).
  * Add debian/rules targets for archiving the tarballs in a separate
    repository using sparse checkouts and git-lfs as storage backend.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 08 Dec 2018 12:42:30 +0100

nvidia-cuda-toolkit (9.1.85-5) unstable; urgency=medium

  * Add nvidia-openjdk-8-jre package shipping the JRE binaries.
  * Use it as JRE for nvidia-visual-profiler and nvidia-nsight on amd64.
    (Closes: #900300)
  * Do not build nvidia-visual-profiler and nvidia-nsight on ppc64el.
  * Bump Standards-Version to 4.2.1 (no changes needed).

 -- Andreas Beckmann <anbe@debian.org>  Tue, 18 Sep 2018 20:22:22 +0200

nvidia-cuda-toolkit (9.1.85-4~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 13 Jun 2018 15:04:43 +0200

nvidia-cuda-toolkit (9.1.85-4) unstable; urgency=medium

  * Visual Profiler and Nsight do not work with default-jre,
    so let nvidia-visual-profiler and nvidia-nsight packages depend on
    openjdk-8-jre and set JAVA_HOME in the nvvp and nsight wrappers
    (LP: #1766948)
  * Let nvidia-profiler depend on libaccinj64-${cuda:SoVersion}

 -- Graham Inggs <ginggs@debian.org>  Wed, 02 May 2018 12:46:27 +0000

nvidia-cuda-toolkit (9.1.85-3) unstable; urgency=medium

  [ Graham Inggs ]
  * Drop libOpenCL.so symlink from nvidia-opencl-dev

  [ Andreas Beckmann ]
  * Switch Vcs-* URLs to salsa.debian.org.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 12 Mar 2018 07:01:23 +0100

nvidia-cuda-toolkit (9.1.85-2) experimental; urgency=medium

  * Let nvidia-opencl-dev depend on ocl-icd-opencl-dev.
    nvidia-libopencl1 only supports up to OpenCL 2.0 and therefore requires
    (no longer available) opencl-c-headers (<< 2.1~) or applications that
    don't use features newer than OpenCL 2.0 (even if the headers declare
    support for newer standards.)  (Closes: #889287)
  * Build the libthrust-dev package. The embedded copy is newer than the last
    release on github.
  * Add clang-4.0 as a supported compiler alternative.
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 26 Feb 2018 17:27:30 +0100

nvidia-cuda-toolkit (9.1.85-1) experimental; urgency=medium

  * New upstream release 9.1 (Dec 2017).  (Closes: #887701)
  * debian/copyright: Synchronize with updated EULA.txt.
  * SOVERSION bump: 9.0 => 9.1, rename all library packages.
  * Refresh patches.
  * Place the documentation in /usr/share/doc/nvidia-cuda-toolkit/.
  * Require libopencl-2.0-1 as alternative.
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 20 Jan 2018 17:26:32 +0100

nvidia-cuda-toolkit (9.0.176-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.3 (no changes needed).
  * Switch to debhelper compat level 11.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 11 Jan 2018 15:01:38 +0100

nvidia-cuda-toolkit (9.0.176-1) experimental; urgency=medium

  * New upstream release 9.0 (Sept 2017).  (Closes: #862522)
  * debian/copyright: Synchronize with updated EULA.txt.
  * Remove libnppi8.0. The full sized library was split up into multiple
    libraries in 8.0 and is now deprecated by upstream.
  * SOVERSION bump: 8.0 => 9.0, rename all library packages.
  * libaccinj64-9.0: New package for the 64-bit ACCINJ library.
  * Update installation paths.
  * Simplify symbols control files and use wildcard matching on symbol
    versions now that upstream uses versioned symbols.
  * Update symbols control files.
  * Refresh patches.
  * man-typos.patch: Fix more misspellings.
  * Fix packaging for ppc64el.
  * Use gcc-6/g++-6 as preferred compiler and clang-3.9 as alternative.
    (Closes: #873468, #864840)
  * Update Lintian overrides.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 24 Nov 2017 00:26:06 +0100

nvidia-cuda-toolkit (8.0.61-3) unstable; urgency=medium

  * Use dpkg makefile snippets instead of manual changelog parsing.
  * Add monolithic cuda tree shim in /usr/lib/cuda/.
    Use for 'clang++ --cuda-path=/usr/lib/cuda'.  (LP: #1706326)
  * Update Lintian overrides.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 23 Nov 2017 05:23:45 +0100

nvidia-cuda-toolkit (8.0.61-2) unstable; urgency=medium

  * Set Priority to optional.
  * Switch from dh_install --list-missing to dh_missing.
  * Ship some overlooked files and drop some removed docs.
  * Factor out a build-stamp target and prepare the tree in build/.
  * Convert packaging repository from SVN to GIT.
  * Add gbp.conf to enable overlay mode.
  * Add get-tarball-dir target to checkout the tarball archive from SVN.


=== debian/control ===
Source: nvidia-cuda-toolkit
Section: non-free/libs
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
 Graham Inggs <ginggs@debian.org>,
 Zhou Mo <cdluminate@gmail.com>,
Build-Depends:
 debhelper-compat (= 11),
 quilt,
 libncurses5,
 libexpat1 [ppc64el],
# for nvidia-openjdk-8-jre
 libasound2 [amd64],
 libgl1 [amd64],
 libgtk2.0-0 [amd64],
 libxslt1.1 [amd64],
 libxtst6 [amd64],
 libxxf86vm1 [amd64],
Rules-Requires-Root: no
Standards-Version: 4.3.0
Homepage: https://developer.nvidia.com/cuda-zone
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-cuda-toolkit
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-cuda-toolkit.git
XS-Autobuild: yes

Package: nvidia-cuda-toolkit
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 nvidia-profiler (= ${binary:Version}),
 nvidia-cuda-dev (= ${binary:Version}),
 nvidia-opencl-dev (= ${binary:Version}) | opencl-dev,
 gcc-6 | clang-4.0 | clang-3.9 | clang-3.8 | clang (<< 1:5~) | gcc-5 | gcc-4.9 | gcc-4.8,
 g++-6 | clang-4.0 | clang-3.9 | clang-3.8 | clang (<< 1:5~) | g++-5 | g++-4.9 | g++-4.8,
 ${shlibs:Depends}, ${misc:Depends},
Recommends:
 nvidia-cuda-doc (= ${source:Version}),
 nvidia-cuda-gdb (= ${binary:Version}),
 nvidia-visual-profiler (= ${binary:Version}) [!ppc64el],
Suggests:
 libcupti-dev,
 nvidia-driver (>= ${nvidia:MinVersion}) [!ppc64el],
Conflicts:
# packages from the repository packages provided by NVIDIA
 cuda-repo-ubuntu1204,
 cuda-repo-ubuntu1404,
 cuda-repo-ubuntu1404-7-5-local,
 cuda-repo-ubuntu1410,
 cuda-repo-ubuntu1504,
 cuda-repo-ubuntu1504-7-5-local,
 cuda-license-7-5,
Description: NVIDIA CUDA development toolkit
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the nvcc compiler and other tools needed for building
 CUDA applications.
 .
 Running CUDA applications requires a supported NVIDIA GPU and the NVIDIA
 driver kernel module.

Package: nvidia-cuda-doc
Section: non-free/doc
Architecture: all
Depends: ${misc:Depends}
Description: NVIDIA CUDA and OpenCL documentation
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the developer documentation.

Package: nvidia-cuda-gdb
Section: non-free/devel
Architecture: amd64 ppc64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version})
Description: NVIDIA CUDA Debugger (GDB)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the cuda-gdb debugger.

Package: nvidia-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 libaccinj64-${cuda:SoVersion},
 libcuinj64-${cuda:SoVersion},
 ${shlibs:Depends}, ${misc:Depends}
Suggests:
 nvidia-cuda-toolkit,
Description: NVIDIA Profiler for CUDA and OpenCL
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This package contains the nvprof profiler.

#Package: nvidia-openjdk-8-jre
#Section: non-free/java
#Architecture: amd64
#Depends:
# ${shlibs:Depends}, ${misc:Depends}
#Description: NVIDIA provided OpenJDK Java runtime, using Hotspot JIT
# Full Java runtime environment - needed for executing Java GUI and Webstart
# programs, using Hotspot JIT.
# .
# This package provides the openjdk-8 binaries shipped with the
# NVIDIA CUDA Toolkit, this obsolete version is needed for
# nvidia-visual-profiler and nvidia-nsight.

Package: nvidia-visual-profiler
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 openjdk-8-jre,
 libgtk2.0-0,
 nvidia-profiler (= ${binary:Version}),
 ${perl:Depends},
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version}),
Homepage: https://developer.nvidia.com/nvidia-visual-profiler
Description: NVIDIA Visual Profiler for CUDA and OpenCL
 The NVIDIA Visual Profiler is a cross-platform performance profiling tool
 that delivers developers vital feedback for optimizing CUDA C/C++ and OpenCL
 applications.

Package: nvidia-nsight
Section: non-free/devel
Architecture: amd64 ppc64el
Depends:
 openjdk-8-jre,
 libgtk2.0-0,
 ${shlibs:Depends}, ${misc:Depends}
Recommends: nvidia-cuda-doc (= ${source:Version}),
Homepage: https://developer.nvidia.com/cuda/nsight-eclipse-edition
Description: NVIDIA Nsight Eclipse Edition
 NVIDIA Nsight Eclipse Edition is a full-featured IDE powered by the Eclipse
 platform that provides an all-in-one integrated environment to edit, build,
 debug and profile CUDA-C applications.
 Nsight Eclipse Edition supports a rich set of commercial and free plugins.

Package: nvidia-cuda-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Depends:
 libaccinj64-${cuda:SoVersion} (= ${binary:Version}),
 libcudart${cuda:SoVersion} (= ${binary:Version}),
 libcuinj64-${cuda:SoVersion} (= ${binary:Version}),
 libnvrtc${cuda:SoVersion} (= ${binary:Version}),
 libnvtoolsext1 (= ${binary:Version}),
 libnvvm3 (= ${binary:Version}),
 libcublas${cuda:SoVersion} (= ${binary:Version}),
 libnvblas${cuda:SoVersion} (= ${binary:Version}),
 libcufft${cuda:SoVersion} (= ${binary:Version}),
 libcufftw${cuda:SoVersion} (= ${binary:Version}),
 libcurand${cuda:SoVersion} (= ${binary:Version}),
 libcusolver${cuda:SoVersion} (= ${binary:Version}),
 libcusparse${cuda:SoVersion} (= ${binary:Version}),
 libnppc${cuda:SoVersion} (= ${binary:Version}),
 libnppial${cuda:SoVersion} (= ${binary:Version}),
 libnppicc${cuda:SoVersion} (= ${binary:Version}),
 libnppicom${cuda:SoVersion} (= ${binary:Version}),
 libnppidei${cuda:SoVersion} (= ${binary:Version}),
 libnppif${cuda:SoVersion} (= ${binary:Version}),
 libnppig${cuda:SoVersion} (= ${binary:Version}),
 libnppim${cuda:SoVersion} (= ${binary:Version}),
 libnppist${cuda:SoVersion} (= ${binary:Version}),
 libnppisu${cuda:SoVersion} (= ${binary:Version}),
 libnppitc${cuda:SoVersion} (= ${binary:Version}),
 libnpps${cuda:SoVersion} (= ${binary:Version}),
 libnvgraph${cuda:SoVersion} (= ${binary:Version}),
 libthrust-dev,
 ${misc:Depends}
Recommends:
 ${package:libcuda1},
 libgl1-mesa-dev | libgl-dev,
 libvdpau-dev,
 libnvcuvid1,
Breaks:
 libcuda1 (<< ${nvidia:MinVersion}),
 libcuinj64-5.5 (<< 5.5.22-6~),
 libcuinj64-6.0 (<< 6.0.37-2~),
Replaces:
 libcuinj64-5.5 (<< 5.5.22-6~),
 libcuinj64-6.0 (<< 6.0.37-2~),
Description: NVIDIA CUDA development files
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the development files: headers and libraries.

Package: nvidia-opencl-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Depends:
 ocl-icd-opencl-dev,
 ${misc:Depends}
Recommends:
 nvidia-opencl-icd,
Breaks:
 nvidia-libopencl1 (>> 0),
Description: NVIDIA OpenCL development files
 OpenCL (Open Computing Language) is a multi-vendor open standard for
 general-purpose parallel programming of heterogeneous systems that include
 CPUs, GPUs and other processors.
 .
 This metapackage provides the development files: headers and libraries.

Package: libcudart9.1
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends:
 ${package:libcuda1}
Provides:
 no-libcuda1 [ppc64el],
Description: NVIDIA CUDA Runtime Library
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 This package contains the CUDA Runtime API library for high-level CUDA
 programming, on top of the CUDA Driver API.

Package: libaccinj64-9.1
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA ACCINJ Library (64-bit)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 ACCINJ is the OpenACC internal library for profiling.
 .
 This package contains the 64-bit ACCINJ runtime library.

Package: libcuinj64-9.1
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: NVIDIA CUINJ Library (64-bit)
 The Compute Unified Device Architecture (CUDA) enables NVIDIA
 graphics processing units (GPUs) to be used for massively parallel
 general purpose computation.
 .
 CUINJ is the CUDA internal library for profiling.
 .
 This package contains the 64-bit CUINJ runtime library.

Package: libnvrtc9.1
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: CUDA Runtime Compilation (NVIDIA NVRTC Library)
 CUDA Runtime Compilation library (nvrtc) provides an API to compile
 CUDA-C++ device source code at runtime.
 .
 The resulting compiled PTX can be launched on a GPU using the CUDA
 Driver API.
 .
 This package contains the NVRTC library.

Package: libnvtoolsext1
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Homepage: https://docs.nvidia.com/gameworks/content/gameworkslibrary/nvtx/nvidia_tools_extension_library_nvtx.htm
Description: NVIDIA Tools Extension Library
 The NVIDIA Tools Extension SDK (NVTX) is a C-based API for marking events and
 ranges in your applications. Applications which integrate NVTX can use Nsight
 to capture and visualize these events and ranges.
 .
 This package contains the NVIDIA Tools Extension runtime library.

Package: libnvvm3
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Homepage: https://developer.nvidia.com/cuda-llvm-compiler
Description: NVIDIA NVVM Library
 NVIDIA's CUDA Compiler (NVCC) is based on the widely used LLVM open source
 compiler infrastructure.
 .
 The NVVM library is used by NVCC to compile CUDA binary code to run on NVIDIA
 GPUs.
 .
 This package contains the NVIDIA NVVM runtime library.

Package: libcupti9.1
Architecture: amd64 ppc64el
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Homepage: https://developer.nvidia.com/cuda-profiling-tools-interface
Description: NVIDIA CUDA Profiler Tools Interface runtime library
 The CUDA Profiler Tools Interface (CUPTI) enables the creation of
 profiling and tracing tools that target CUDA applications.  CUPTI
 provides a set of APIs targeted at ISVs creating profilers and other
 performance optimization tools. The CUPTI APIs are not intended to be
 used by developers in their CUDA applications.
 .
 This package contains the runtime library.

Package: libcupti-dev
Section: non-free/libdevel
Architecture: amd64 ppc64el
Multi-Arch: same
Depends: libcupti${cuda:SoVersion} (= ${binary:Version}), ${misc:Depends}
Recommends: libcupti-doc
Homepage: https://developer.nvidia.com/cuda-profiling-tools-interface
Description: NVIDIA CUDA Profiler Tools Interface development files
 The CUDA Profiler Tools Interface (CUPTI) enables the creation of
 profiling and tracing tools that target CUDA applications.  CUPTI
 provides a set of APIs targeted at ISVs creating profilers and other

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

VENDOR			?= $(call dpkg_late_eval,VENDOR,dpkg-vendor --derives-from Ubuntu && echo Ubuntu || echo Debian)


include debian/rules.defs
CUDA_ARCH_LIST		?= amd64
CUDA_VERSION_TOOLKIT	?= $(DEB_VERSION_UPSTREAM)
CUDA_VERSION_MAJOR	?= $(word 1,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
CUDA_VERSION_MINOR	?= $(word 2,$(subst ., ,$(CUDA_VERSION_TOOLKIT)))
version_driver		 = $(CUDA_VERSION_DRIVER.$(DEB_HOST_ARCH))
watch_url		 = $(CUDA_WATCH_URL)
THRUST_VERSION		?= $(shell perl -ne 'if (/define\s+THRUST_VERSION\s+(\d*)/) { printf "%d.%d.%d\n", $$1 / 100000, $$1 / 100 % 1000, $$1 % 100; }' nvidia-cuda/include/thrust/version.h)
OPENJDK_VERSION		?= $$(nvidia-cuda/jre/bin/java -version 2>&1 | sed -rn '1s/.*"1\.([0-9]*)\.0_(.*)"/\1u\2/p')
CUDA_JAVA_HOME		?= /usr/lib/jvm/java-8-openjdk-$(DEB_HOST_ARCH)

package_libcuda1 \
	= libcuda1 (>= $${nvidia:MinVersion}) \
	| libcuda-$${cuda:SoVersion}-1
#ifeq ($(VENDOR),Ubuntu)
package_libcuda1	+= | no-libcuda1 [ppc64el]
#endif

# system libdir
libdir			 = usr/lib/$(DEB_HOST_MULTIARCH)

TEMPLATES	:= $(wildcard debian/*.in debian/patches/*.in)
SOVERTEMPLATES	:= $(wildcard debian/*SOVER*)
AUTOGEN         += $(patsubst %.in,%,$(TEMPLATES))
AUTOGEN		+= $(subst SOVER,$(CUDA_SOVERSION),$(sort $(patsubst %.in,%,$(SOVERTEMPLATES))))
AUTOGEN		+= debian/g++
AUTOKEEP	 = debian/watch
AUTOCLEAN	 = $(filter-out $(AUTOKEEP),$(AUTOGEN))
AUTOCLEAN	+= debian/shlibs.local


.PHONY: autogen prepare
autogen: $(AUTOGEN)
prepare: autogen unpack-stamp compare-copyright-license


nvidia-cuda-amd64:
	dh_testdir
	$(RM) -r $@ $@.tmp
	sh $(CUDA_FILENAME.amd64) --noexec --keep --target $@.tmp
	$(RM) -r $@.tmp/jre
	mv $@.tmp $@

nvidia-cuda-ppc64el:
	dh_testdir
	$(RM) -r $@ $@.tmp
	mkdir $@.tmp
	@set -e -x ; for deb in ppc64el/cuda*.deb ; do dpkg -x $$deb $@.tmp/ubuntutree ; done
	mv $@.tmp/ubuntutree/usr/local/cuda*/* $@.tmp/
	$(RM) -r $@.tmp/ubuntutree/usr/lib/pkgconfig
	$(RM) -r $@.tmp/ubuntutree/usr/share/doc
	$(RM) -r $@.tmp/ubuntutree/usr/share/lintian
	$(RM) -v $@.tmp/ubuntutree/etc/ld.so.conf.d/cuda-$(subst .,-,$(CUDA_SOVERSION)).conf
	$(RM) -v $@.tmp/bin/computeprof
	$(RM) -v $@.tmp/LICENSE
	$(RM) -v $@.tmp/README
	mv $@.tmp/doc/EULA.txt $@.tmp/
	$(RM) $@.tmp/include $@.tmp/lib64
	mv $@.tmp/targets/ppc64le-linux/include $@.tmp/include
	mv $@.tmp/targets/ppc64le-linux/lib $@.tmp/lib64
	mv $@.tmp $@

unpack-stamp: $(filter debian/patches%,$(AUTOGEN))
unpack-stamp: nvidia-cuda-$(DEB_HOST_ARCH)
	$(RM) -f nvidia-cuda
	ln -sf nvidia-cuda-$(DEB_HOST_ARCH) nvidia-cuda
	QUILT_PATCHES=debian/patches QUILT_SERIES=series-postunpack quilt --quiltrc /dev/null push -a || test $$? = 2
	touch $@

# Reformat the EULA to the format needed for debian/copyright.
nvidia-cuda/EULA.txt: unpack-stamp
EULA.fmt: nvidia-cuda/EULA.txt
	cat $<  | fromdos | fromdos | expand \
		| iconv -f UTF-8 -t latin1//TRANSLIT \
		| fold -s -w 80 \
		| sed -e 's/ *$$//;s/^$$/./;s/^/ /;' \
		> $@

# Compare the license in debian/copyright with the EULA shipped in the archive.
compare-copyright-license: EULA.fmt
	sed -e '1,/^License: other-NVIDIA-CUDA-TOOLKIT/d; /^$$/,$$d; /^ .$$/d' debian/copyright > copyright.tmp
	sed -e '/^ .$$/d' EULA.fmt > EULA.tmp
	diff -w copyright.tmp EULA.tmp
	rm -f copyright.tmp EULA.tmp


.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install
binary-arch build build-arch build-indep clean install:
	dh $@

binary binary-indep:
	# the documentation packages must be built on amd64 (otherwise some parts are missing)
	test "$(DEB_HOST_ARCH)" = "amd64"
	dh $@

override_dh_auto_configure: $(AUTOGEN) unpack-stamp

build-stamp: unpack-stamp
	$(RM) -r build
	cp -al nvidia-cuda-$(DEB_HOST_ARCH)/ build
	test -f build/version.txt || echo "CUDA Version $(CUDA_VERSION_TOOLKIT)" > build/version.txt
	chmod -x build/libnvvp/*.xpm
	chmod -x build/libnsight/*.xpm
	sed -i '/^-vm$$/ d; /^..\/jre\/bin\/java$$/ d' build/libnvvp/nvvp.ini build/libnsight/nsight.ini
	chmod -x build/bin/crt/link.stub
	chmod -x build/bin/crt/prelink.stub
	chmod -x build/nvvm/include/*.h
	chmod -x build/nvvm/libnvvm-samples/build.bat
	# reduce 'dh_missing --list-missing' noise
	$(RM) -r build/lib32
	$(RM) -r build/*/lib32
	# depend on libraries from oldoldstable
	$(RM) -v build/jre/lib/amd64/libavplugin-53.so
	$(RM) -v build/jre/lib/amd64/libavplugin-54.so
	# remove tracking scripts
	$(RM) -rv build/doc/html/common/scripts
	# remove tracking images
	find build/doc/html -name '*.html' -exec sed -r -i \
		-e '\,http://omniture.nvidia.com/b/ss/nvidiacudadocs/1/H.17--NS/0, { s,(<noscript>),<!-- \1,; s,img src,img DISABLED,; s,(</noscript>),\1 -->, }' \
		-e 's,(<script type="text/javascript" )src(="http://w.sharethis.com/button/buttons.js"[^>]*></script>),<!-- \1DISABLED\2 -->,' \
		-e 's,(<script type="text/javascript" charset="utf-8" )src(="//assets.adobedtm.com/b92787824f2e0e9b68dc2e993f9bd995339fe417/satelliteLib-7ba51e58dc61bcb0e9311aadd02a0108ab24cc6c.js"[^>]*></script>),<!-- \1DISABLED\2 -->,' \
		{} +
	find build/libnsight build/libnvvp -name 'license.html' -exec sed -r -i \
		-e 's,(<script type="text/javascript" )src(="http://w.sharethis.com/button/buttons.js"[^>]*></script>),<!-- \1DISABLED\2 -->,' \
		{} +
	# split arch and indep eclipse plugins
	mkdir build/libnsight/plugins-arch
	mv build/libnsight/plugins/org.eclipse.equinox.launcher.gtk.linux.* build/libnsight/plugins-arch/
	mkdir build/libnvvp/plugins-arch
	mv build/libnvvp/plugins/org.eclipse.equinox.launcher.gtk.linux.* build/libnvvp/plugins-arch/
	touch $@

override_dh_auto_build: build-stamp

override_dh_auto_install:
	mkdir debian/tmp
	cp -al build/ debian/tmp/usr

override_dh_installdocs-indep:
	dh_installdocs -pnvidia-cuda-doc --doc-main-package=nvidia-cuda-toolkit
	dh_installdocs --remaining-packages

override_dh_installman:
	dh_installman --language=C

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -X/stubs/

override_dh_shlibdeps:
	mkdir libcuda
	ln -s ../nvidia-cuda/lib64/stubs/libcuda.so libcuda/libcuda.so.1
	echo 'libcuda 1 XXXlibcuda1XXX' > debian/shlibs.local
	dh_shlibdeps -X/stubs/ -- -llibcuda
	$(RM) -r libcuda debian/shlibs.local
	sed -i -r 's/XXXlibcuda1XXX/$${package:libcuda1}/g' debian/*.substvars

# running dh_strip is not permitted by the NVIDIA license
override_dh_strip:
override_dh_strip_nondeterminism:

override_dh_compress:
	dh_compress -Xusr/share/doc/nvidia-cuda-doc/examples -Xusr/share/doc/libcupti-doc/examples

override_dh_gencontrol-indep:
	dh_gencontrol -plibthrust-dev -- -v$(THRUST_VERSION)~$(DEB_VERSION)
	dh_gencontrol --remaining-packages

override_dh_gencontrol-arch:
ifeq ($(DEB_HOST_ARCH),amd64)
#	dh_gencontrol -pnvidia-openjdk-8-jre -- -v$(OPENJDK_VERSION)~$(DEB_VERSION)
endif
	dh_gencontrol -- \
		-V'package:libcuda1=$(package_libcuda1)' \
		-V'cuda:SoVersion=$(CUDA_SOVERSION)' \
		-V'nvidia:MinVersion=$(version_driver)'

override_dh_auto_clean:
	$(RM) -r .pc
	$(RM) nvidia-cuda
	$(RM) -r nvidia-cuda-amd64
	$(RM) -r nvidia-cuda-ppc64el
	$(RM) -r build
	$(RM) -r libcuda
	$(RM) EULA.fmt EULA.tmp copyright.tmp

override_dh_clean:
	dh_clean
	$(RM) $(AUTOCLEAN)
	$(MAKE) -f debian/rules $(AUTOKEEP)


# Generating control files
%:: %.in debian/rules debian/rules.defs
	perl -p \
	-e 's{#VERSION_TOOLKIT#}{$(CUDA_VERSION_TOOLKIT)}g;' \
	-e 's{#SOVERSION#}{$(CUDA_SOVERSION)}g;' \
	-e 's{#CUDA_DOWNLOAD_URL#}{$(watch_url)}g;' \
	-e 's{#LIBDIR#}{$(libdir)}g;' \
	-e 's{#MAN_DATE#}{$(CUDA_MAN_DATE.$(DEB_HOST_ARCH))}g;' \
	-e 's{#!ppc64el#}{$(if $(filter ppc64el,$(DEB_HOST_ARCH)),#)}g;' \
	-e 's{#CUDA_JAVA_HOME#}{$(CUDA_JAVA_HOME)}g;' \
	< $< > $@

lib%$(CUDA_SOVERSION).install:: lib%SOVER.install
	cp $< $@

lib%$(CUDA_SOVERSION).links:: lib%SOVER.links
	cp $< $@

lib%$(CUDA_SOVERSION).lintian-overrides:: lib%SOVER.lintian-overrides
	cp $< $@

lib%$(CUDA_SOVERSION).symbols:: lib%SOVER.symbols
	cp $< $@
